Subject: Make system call to php binary reliable one for all, especially on Windows
Description

Currently, there are still issues with \TYPO3\FLOW3\Core\Booting\Scripts'
1            $phpBinaryPathAndFilename = escapeshellcmd(\TYPO3\FLOW3\Utility\Files::getUnixStylePath($settings['core']['
phpBinaryPathAndFilename']));
2            $command = '"' . $phpBinaryPathAndFilename . '" -c ' . escapeshellarg(php_ini_loaded_file()) . ' -v';
3            system($command, $result);
4            if ($result !== 0) {
5                throw new \TYPO3\FLOW3\Exception('It seems like the PHP binary "' . $settings['core']['
phpBinaryPathAndFilename'] . '" cannot be executed by FLOW3. Set the correct path to the PHP executable in
Configuration/Settings.yaml, setting FLOW3.core.phpBinaryPathAndFilename.', 1315561483);
6            }
7            throw new \TYPO3\FLOW3\Exception('The compile run failed. Please check the error output or system log for more
information.', 1297263663);
8

Its very likely that this call still doesn't success in complicated Windows environment, where the path is e.g. set to C:\Program Files
(x86)\Zend\ZendServer\bin\php.exe. Even that escapeshellcmd brings up errors because the (x86) is converted to  ^(x86^).

Additionally, the exception message should be more verbose and at least carry the actual $command in order to make error catching
more easy.
A few additional file_exists and other stuff may also make that stuff more reliable.

Associated revisions
Revision 17c31e32 - 2012-12-05 12:40 - Alexander Berl

[TASK] Make system call to php binary reliable, especially on Windows

This solves execution of php binary on windows environments with paths
containing whitespace and special characters (like round brackets). On
windows, commands containing white spaces must be quoted, but quoted paths may
not be escaped, which escapeshellcmd() wrongly does.

This is solved by using escapeshellarg() on windows instead and also adds more
verbose exception messages in the case of failure.

Change-Id: Ibc7876a8e98f653afaf0bf8c7a4893e0b808cf23
Resolves: #35916
Releases: 1.1, 1.2

2015-08-03 1/4



Revision d8ce798d - 2012-12-11 10:13 - Alexander Berl

[TASK] Make system call to php binary reliable, especially on Windows

This solves execution of php binary on windows environments with paths
containing whitespace and special characters (like round brackets). On
windows, commands containing white spaces must be quoted, but quoted
paths may not be escaped, which escapeshellcmd() wrongly does.

This is solved by using escapeshellarg() on windows instead and also
adds more verbose exception messages in the case of failure.

Change-Id: Ibc7876a8e98f653afaf0bf8c7a4893e0b808cf23
Resolves: #35916
Releases: 1.1, 1.2

History
#1 - 2012-04-13 15:44 - Alexander Berl

Further details on the escaping problem, which is actually a PHP Bug can be found here:
https://bugs.php.net/bug.php?id=43261
The last comment from 2012-02-12 17:38 UTC is by me, but since this bug is as old as 2008 I doubt it will get fixed anytime.

Other than that +1 for the more verbose exception message and would suggest it also includes the system call return value (last line of output from
the call), since this sometimes contains helpful information too. I was stumbled a few times on an "It seems like the PHP binary..." message, which was
actually caused by an PHP Syntax error or similar, causing the system call to fail.

#2 - 2012-05-08 17:58 - Bastian Waidelich
- Category set to Core
- Assigned To deleted (Bastian Waidelich)

Definitely makes sense, but I can't take care of it atm

#3 - 2012-05-21 17:00 - Karsten Dambekalns
- Target version deleted (1.1)

#4 - 2012-08-02 02:09 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13423

#5 - 2012-08-10 14:44 - Karsten Dambekalns
- Assigned To set to Karsten Dambekalns
- Target version set to 1.1
Assigning to me (so it doesn't get lost), because the change author is not assignable.

#6 - 2012-08-10 14:49 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13423

#7 - 2012-08-10 14:51 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13423

#8 - 2012-08-17 11:19 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1.1

#9 - 2012-12-05 11:45 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13423

#10 - 2012-12-05 11:56 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13423

#11 - 2012-12-05 11:57 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13423

#12 - 2012-12-05 12:40 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13423

#13 - 2012-12-11 10:13 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/17093

#14 - 2012-12-12 22:12 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
Applied in changeset commit:17c31e32c08a8a98bd851226137804c243bfeac1.
